﻿package 
{
	import flash.display.SimpleButton;
	import flash.display.Sprite;
	import flash.events.Event;
	
	//importするpapervisionのクラス
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.render.BasicRenderEngine;
	import org.papervision3d.cameras.Camera3D;
	import object3ds.VF25;
	import object3ds.VF25fighter3;
	import object3ds.VF25fighter2;
	import object3ds.Teapot;
	import object3ds.factoryObject3d.FactoryObject3d;
	
	/**
	 * ...
	 * @author l
	 */
	public class Main extends Sprite 
	{
			private var scene:Scene3D;
			private var viewport:Viewport3D;
			private var camera:Camera3D;
			private var render:BasicRenderEngine;
			private var alto:VF25;
			private var alto3:VF25fighter3;
			private var alto2:VF25fighter2;
			private var teapot:Teapot;
			
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init, false, 0, true);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			//シーンと登場物の作成
			scene = new Scene3D();
			
			alto = new VF25(true,"VF25",true);
			alto.addEventListener(FactoryObject3d.COMPLETE_CREATE_OBJECT3D, completeCreatObject);
			alto.createObject3d();		
			
			// カメラの作成とカメラ座標の設定
			camera = new Camera3D();
			camera.x = 250;
			camera.y = 0;
			camera.z = 250;
			camera.zoom = 36;
			camera.lookAt(alto);
			
			//ビューポートを作成
			viewport = new Viewport3D(800, 600);
			this.addChild(viewport);
			
			// レンダラの作成
			render = new BasicRenderEngine();  
			
			//ENTER_FRAMEにてレンダリングを行う
			this.addEventListener(Event.ENTER_FRAME, render3D);
		}
		
		private function render3D(event:Event):void 
		{
  			//カメラの上下移動
			camera.y = (mouseY - stage.stageHeight * 0.5) *10 ;
			camera.x = (mouseX - stage.stageWidth * 0.5) * 5  ;
			
			// カメラが物を見るように設定してレンダリング
			camera.lookAt(alto);
			render.renderScene(scene, camera, viewport);
		}
		
		private function completeCreatObject(event:Event):void
		{
			scene.addChild(event.target as FactoryObject3d);
		}	
		
	}
	
}